#include "opencv2/opencv.hpp"
#include <vector>
#include <string>
#include <iostream>

int main (int argc, char *argv[])
{
    cv::namedWindow("Edges", 0);
    int threshold = 0;
    int last = -1;
    cv::createTrackbar("threshold", "Edges", &threshold, 255, NULL);

    cv::Mat frame = cv::imread("../lena.jpg",cv::IMREAD_COLOR);
    if (frame.empty()) return -1;

    cv::cvtColor(frame,frame,cv::COLOR_BGR2GRAY);

    cv::imshow("Edges",frame);
    cv::waitKey(0);

    cv::blur(frame,frame,cv::Size(5,5));

    cv::Mat dx, dy, absdx, absdy, float_edges, gray_edges, binary_edges, slope;
    cv::Sobel(frame, dx, CV_32F, 0, 1, -1);
    cv::Sobel(frame, dy, CV_32F, 1, 0, -1);
    cv::absdiff(dx,0,absdx);
    cv::absdiff(dy,0,absdy);
    cv::addWeighted(absdx,0.5,absdy,0.5,0,float_edges);
    //cv::cartToPolar(dx,dy,float_edges,slope);
    double maximum;
    cv::minMaxLoc(float_edges,NULL,&maximum);
    std::cout << maximum << std::endl;
    cv::threshold(float_edges,gray_edges,255,255,cv::THRESH_TRUNC);
    gray_edges.convertTo(gray_edges,CV_8U);

    cv::Mat normalized_dx, normalized_dy, normalized_slope;
    cv::normalize(dx,normalized_dx,0,255,cv::NORM_MINMAX,CV_8U);
    cv::normalize(dy,normalized_dy,0,255,cv::NORM_MINMAX,CV_8U);
    cv::imshow("Edges",normalized_dx);
    cv::waitKey(0);
    cv::imshow("Edges",normalized_dx);
    cv::waitKey(0);
    cv::imshow("Edges",gray_edges);
    cv::waitKey(0);
    if (!slope.empty()) {
        cv::normalize(slope,normalized_slope,0,255,cv::NORM_MINMAX,CV_8U);
        cv::imshow("Edges",normalized_slope);
        cv::waitKey(0);
    }

    for (;;) {
        if (threshold != last) {
            last = threshold;

            cv::threshold(gray_edges,binary_edges,threshold,255,cv::THRESH_BINARY);

            cv::imshow("Edges",binary_edges);
        }

		int key = cv::waitKey(10);
		if (key == 27) break;
	}
	return 0;
}
